t_buildname={"Barricade",nil,"Wall I","Wall II","Wall III","Gate Field","Dispenser","Turret","Supply",nil,nil,nil,"Teleporter Entrance","Teleporter Exit"}
t_buildprice={300,       nil, 1000,    2000,     3000,      1500,        5000,       5000,    5000,   nil,nil,nil, 3000,                 3000}
t_buildtime={ 100,       nil, 100,     125,      225,       175,         225,        250,     250,    nil,nil,nil, 150,                  150}
t_upgradespd={2,         nil, 10,      10,       nil,       nil,         nil,        75,      100,    nil,75}


t_hpstart={255,0,0}
t_hpend={0,255,0}
t_upgradecolor={255,255,0}
v_regen=50
v_upgradehp=true



dhook("build","flua.cs._build")
dhook("always","flua.cs._always")
dhook("clientdata","flua.cs._clientdata")
dhook("objectdamage","flua.cs._objectdamage")
dhook("objectupgrade","flua.cs._objectupgrade")



t_buildhp={150,300,500,1000,2000,1000,1000,500,1000,100,750,1000,500,500,1500}
t_uptrans={3,nil,4,5,nil,nil,nil,11,15,nil,12}

t_consite={}
t_upgrade={}
t_mouse={}
t_image={}



function flua.cs._build(id,type,x,y,mode,objectid)
	if ((type==1) or (type>=3 and type<=9) or (type>=13 and type<=14)) then
		t_consite[id]={x,y,type,t_buildtime[type],0}
		parse("setmoney "..id.." "..player(id,"money")-t_buildprice[type])
		parse("spawnobject 10 "..x.." "..y.." 0 0 "..player(id,"team").." "..id)
		return 1
	end
end

function flua.cs._always()
	reqcld(0,2)
	for _,id in ipairs(player(0,"table")) do
		if objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"exists") then
			if objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"type")>=1 and objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"type")<=15 then
				if type(t_image[id])~="table" then
					t_image[id]={image(imgdir.."/upgrade-bar.png",t_mouse[id][1],t_mouse[id][2]+46,3,id),image(imgdir.."/upgrade-meter.png",t_mouse[id][1],t_mouse[id][2]+46,3,id),image(imgdir.."/upgrade-meter.png",t_mouse[id][1],t_mouse[id][2]+46,3,id)}
					imagecolor(t_image[id][1],255,255,255)
					imagecolor(t_image[id][3],255,255,0)
				end
				for v_temp=1,3 do
				imagepos(t_image[id][v_temp],t_mouse[id][1],t_mouse[id][2]+46,0)
				imagealpha(t_image[id][v_temp],0.5)
				end
				if t_upgrade[objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"id")]~=nil then
					percent=(t_upgrade[objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"id")]/t_upgradespd[objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"type")])*100
				else
					percent=0
				end
				imagescale(t_image[id][3],percent,1)
				if objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"type")==10 then
					percent=((t_buildtime[t_consite[id][3]]-t_consite[id][4])/t_buildtime[t_consite[id][3]])*100
				else
					percent=(objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"health")/t_buildhp[objectpos(math.floor(t_mouse[id][1]/32),math.floor(t_mouse[id][2]/32),"type")]*100)
				end
				imagecolor(t_image[id][2],(t_hpstart[1]+(percent*(t_hpend[1]-t_hpstart[1])))/100,(t_hpstart[2]+(percent*(t_hpend[2]-t_hpstart[2])))/100,(t_hpstart[3]+(percent*(t_hpend[3]-t_hpstart[3])))/100)
				imagescale(t_image[id][2],percent,1)
			end
		else
			if type(t_image[id])=="table" then
				for v_temp=1,3 do
				freeimage(t_image[id][v_temp])
				end
				t_image[id]=nil
			end
		end
		if type(t_consite[id])=="table" then
			if t_consite[id][5]>0 then
				t_consite[id][5]=t_consite[id][5]-1
			else
				t_consite[id][4]=t_consite[id][4]-1
				if t_consite[id][4]<=0 then
					parse("killobject "..objectpos(t_consite[id][1],t_consite[id][2],"id"))
					parse("spawnobject "..t_consite[id][3].." "..t_consite[id][1].." "..t_consite[id][2].." 0 0 "..player(id,"team").." "..id)
					t_consite[id]=nil
				end
			end
		end
	end
end

function flua.cs._clientdata(id,mode,data1,data2)
	if mode==2 then
		t_mouse[id]={data1,data2}
	end
end

function flua.cs._objectdamage(id,damage,pl)
	if object(id,"type")==10 then
		t_consite[object(id,"player")][4]=t_consite[object(id,"player")][4]+damage
		t_consite[object(id,"player")][5]=v_regen
		if t_consite[object(id,"player")][4]>=t_buildtime[t_consite[object(id,"player")][3]] then
			t_consite[object(id,"player")]=nil
			parse("killobject "..id)
		end
		return 1
	else
		if t_upgrade[id]~=nil and t_upgrade[id]>0 then
			if v_upgradehp then
				if t_upgrade[id]-damage<=0 then
					t_upgrade[id]=nil
				else
					t_upgrade[id]=t_upgrade[id]-damage
					return 1
				end
			else
				t_upgrade[id]=nil
			end
		end
	end
end

function flua.cs._objectupgrade(id,pl)
	if t_upgrade[id]==nil then
		t_upgrade[id]=1
	else
		t_upgrade[id]=t_upgrade[id]+1
		if t_upgrade[id]>=t_upgradespd[object(id,"type")] then
			oldtype={object(id,"type"),object(id,"tilex"),object(id,"tiley"),object(id,"player")}
			parse("killobject "..id)
			parse("spawnobject "..t_uptrans[oldtype[1]].." "..oldtype[2].." "..oldtype[3].." 0 0 "..player(oldtype[4],"team").." "..oldtype[4])
			t_upgrade[id]=nil
		end
	end
	parse("setmoney "..pl.." "..player(pl,"money")-100)
	return 1
end

function objectpos(tilex,tiley,value)
	for _,id in ipairs(object(0,"table")) do
		if object(id,"tilex")==tilex and object(id,"tiley")==tiley then
			if string.lower(value)=="id" then
				return id
			else
				return object(id,value)
			end
		end
	end
return false
end
