dofile(settingsdir.."/dofile.lua")
usersfiledir_=usersdir.."/users.txt"

function checkuser(filedir,id)
	local usgn = player(id,"usgn")
	local file = assert(io.open(filedir,"r"))
	for line in io.lines(filedir) do
		local parses = toTable(line)
		if (tonumber(parses[1])==usgn) then
			playerpower[id] = tonumber(parses[2])
			Script_Colors[id] = parses[3]
			Script_Name[id]=parses[4]
			Script_Rank[id]=parses[5]
			break
		end
	end
	return nil
end

function savedata(filedir,id)
	if(Script_Name[id] and player(id,"usgn")>0) then
		local usgn = player(id,"usgn")
		local lines = {}

		for line in io.lines(filedir) do
			table.insert(lines,line)
		end

		local appendrewrite = assert(io.open(filedir,"w"))
		for i=1, #lines do
			if lines[i] ~= nil then
				if(tonumber( toTable(lines[i])[1] ) ~= usgn) then
					appendrewrite:write(lines[i],"\n")
				else
					appendrewrite:write(usgn," ",playerpower[id]," ",Script_Colors[id]," ",Script_Name[id]," ",Script_Rank[id],"\n")
				end
			end
		end
		appendrewrite:close()
		return 0
	end
end

function flua.cs.joinadmin(id)
	if(player(id,"usgn")>0) then
		checkuser(usersfiledir_,id)
	end
end

dhook("minute","flua.cs.minute")
function flua.cs.minute()
	if(nameweb=="") then
		msg(yoursimplename.." "..FireLangLua47)
	else
		msg("255255000"..FireLangLua43.." "..nameweb.." ("..FireLangLua44..")")
		msg("255255255"..FireLangLua45.." "..nameclan.." "..FireLangLua46.." "..nameweb)
		msg(yoursimplename.." "..FireLangLua47)
	end
end



dhook("leave","flua.cs.ping")
function flua.cs.ping(p,r)
	if r==1 then
		timeouts[p]={0,0}
		msg(player(p,"name").." "..FireLangLua48.." ("..FireLangLua49..").")
	end
end



dhook("leave","flua.cs.leaveadmin")
function flua.cs.leaveadmin(id,p)
	savedata(usersfiledir_,id)
	playerpower[id] = 0
	Script_Colors[id]= "050150255"
	Script_Name[id]=nil
	Script_Rank[id]=nil
	timeouts[p]={0,0}
	blinded_pl[id] = 0
	changename[id] = 0
end