dhook("die", "flua.cs.dieplayer")
dhook("second", "flua.cs.secondplayer")
dhook("join", "flua.cs.joinplayer")

for rtd_temp=1,32 do
	rtd_blindedplayer[rtd_temp]=false
	rtd_poison[rtd_temp]=0
	rtd_selfdestruct[rtd_temp]=nil
end

function resetvariables(id)
	rtd_blindedplayer[id]=false
	rtd_poison[id]=0
	rtd_selfdestruct[id]=nil
end

function flua.cs.secondplayer()
blindedplayer()
poison()
self_destruct()
end

function self_destruct()
	for rtd_temp=1,32 do
		if rtd_selfdestruct[rtd_temp]~=nil then
			if rtd_selfdestruct[rtd_temp]==1 then
			msg(copyright..change_color["red"]..player(rtd_temp, "name").." WILL SELF DESTRUCT IN "..rtd_selfdestruct[rtd_temp].." SECOND!!@C")
			rtd_selfdestruct[rtd_temp]=rtd_selfdestruct[rtd_temp]-1
			elseif rtd_selfdestruct[rtd_temp]==0 then
			parse("explosion "..player(rtd_temp, "x").." "..player(rtd_temp, "y").." 512 999")
			rtd_selfdestruct[rtd_temp]=nil
			else
			msg(copyright..change_color["red"]..player(rtd_temp, "name").." WILL SELF DESTRUCT IN "..rtd_selfdestruct[rtd_temp].." SECONDS!!@C")
			rtd_selfdestruct[rtd_temp]=rtd_selfdestruct[rtd_temp]-1
			end
		end
	end
end

function poison()
	for rtd_temp=1,32 do
		if player(rtd_temp, "exists") and player(rtd_temp, "health")>0 then
			if rtd_poison[rtd_temp]~=0 then
				parse("sethealth "..rtd_temp.." "..math.floor(player(rtd_temp, "health")-rtd_poison[rtd_temp]))
			end
		end
	end
end

function flua.cs.joinplayer(id)
resetvariables(id)
end

function blindedplayer()
	for rtd_temp=1,32 do
		if rtd_blindedplayer[rtd_temp]==true then
			parse("flashplayer "..rtd_temp.." 100")
		end
	end
end

function flua.cs.dieplayer(id)
rtd_blindedplayer[id]=false
rtd_selfdestruct[id]=nil
rtd_poison[id]=0
end


function roll_dice(p)
        local r = 1 + rand(15)
        if r == 1 then
		parse("setmaxhealth "..p.." 250")
		parse("sethealth "..p.." 250")
		msg("000000000"..player(p, "name").." feels VERY healthy!@C")
        elseif r == 2 then
                parse("setmaxhealth "..p.." 100")
                parse("sethealth "..p.." 1")
		msg("000000000"..player(p, "name").." needs an AMBULANCE!@C")
        elseif r == 3 then
		rtd_poison[p] = 5
		msg("000000000"..player(p, "name").." is feeling very SICK!@C")
        elseif r == 4 then
		rtd_poison[p] = -5
		parse("setmaxhealth "..p.." 100")
		msg("000000000"..player(p, "name").." found a WHOLE LOT of bandages!@C")
        elseif r == 5 then
	        rtd_selfdestruct[p] = 15
	        parse("speedmod "..p.." 20")
	        parse("strip "..p)
	        parse("setarmor "..p.." 200")
	        parse("setmaxhealth "..p.." 250")
	        parse("sethealth "..p.." 250")
        elseif r == 6 then
		rtd_selfdestruct[p] = 15
        elseif r == 7 then
		parse("speedmod "..p.." 100")
		msg("000000000"..player(p, "name").." found a pair of BIONIC LEGS!@C")
        elseif r == 8 then
		parse("speedmod "..p.." -20")
		msg("000000000"..player(p, "name").." gained some serious WEIGHT!@C")
        elseif r == 9 then
		parse("equip "..p.." 47")
		msg("000000000"..player(p, "name").." is going EXPLOSIVE!@C")
	elseif r == 10 then
		parse("strip "..p)
		msg("000000000"..player(p, "name").." is completely NAKED!@C")
	elseif r == 11 then
		for rtd_temp=1,20 do parse("spawnobject 2 "..math.random(1, map("xsize")).." "..math.random(1, map("ysize"))) end
		msg("000000000"..player(p, "name").." watched too much SAW!@C")
        elseif r == 12 then
                for rtd_temp=1,20 do parse("spawnobject "..math.random(3,5).." "..math.random(1, map("xsize")).." "..math.random(1, map("ysize"))) end
                msg("000000000"..player(p, "name").." feels the WALLS closing in!@C")
        elseif r == 13 then
                for rtd_temp=1,20 do parse("spawnobject 20 "..math.random(1, map("xsize")).." "..math.random(1, map("ysize"))) end
                msg("000000000"..player(p, "name").." plays MINESWEEPER!@C")
        elseif r == 14 then
                for rtd_temp=1,20 do parse("spawnobject 8 "..math.random(1, map("xsize")).." "..math.random(1, map("ysize"))) end
                msg("000000000"..player(p, "name").." screams TAKE COVER!@C")
	elseif r == 15 then
		if (rand(100) < 25) then
		        for id = 1, 32 do
			        if (player(id, "exists") and player(id, "health") > 0) then
			                for i = 1, 88, 1 do
			                        if i < 79 or i > 84 then
		                        if i ~= 64 and i ~= 65 and i ~= 70 and i ~= 71 then
		                                parse("equip "..id.." "..i)
		                        end
		                        end
		                end
		        end
		        end

			msg("000000000"..player(p, "name").." says MERRY CHRISTMAS!@C")
		else
			msg("000000000"..player(p, "name").." milked a COW!@C")
	                parse("sv_sound weapons/moo1.wav")
		end
	elseif r == 16 then
		msg("000000000"..player(p, "name").." fell down a MANHOLE!@C")
		parse("sv_sound player/die_abyss.ogg")
        end
end

function rand(limit)
        if (not limit) then limit = 1 end
        local rnum = math.random(limit + 1) - 1
        return rnum
end